package com.ruoyi.ibs.list.service;


import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.ibs.list.domain.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.rmi.ServerException;
import java.util.HashMap;
import java.util.List;

/**
 * 客群圈选分群Service接口
 *
 * @author ruoyi
 * @date 2024-09-11
 */
public interface ISysGroupService {
    /**
     * 查询客群圈选分群
     *
     * @param id 客群圈选分群主键
     * @return 客群圈选分群
     */
    public SysGroup selectSysGroupById(Long id);

    /**
     * 查询客群圈选分群
     *
     * @param groupId
     * @return 客群圈选分群
     */
    public SysGroup selectSysGroupByGroupId(String groupId);

    /**
     * 获取客群名称
     *
     * @param
     * @return 客群圈选分群
     */
    public String selectSysGroupNameByGroupId(String groupId);

    public List<SysGroup> selectSysGroupListBydeptId();

    /**
     * 查询客群圈选分群列表
     *
     * @param groupName 客群名称
     * @return 客群圈选分群集合
     */
    public List<SysGroupVo> selectSysGroupList(String groupName, String listType,String createBy,SysGroupSortVo groupSortVo,String type);

    /**
     * 任务列表查看客群详情
     * @param groupId
     * @param customerList
     * @param groupType
     * @return
     */
    public List<CustomerList> selectCustomerList(String groupId, CustomerList customerList,String groupType);

    /**
     * 客群列表查看客群详情（初始导入的）
     * @param groupId
     * @param customerList
     * @param groupType
     * @return
     */
    public List<CustomerList> selectCustomerListDetail(String groupId, CustomerList customerList,String groupType);


    public HashMap isHead(String username);

    /**
     * 新增客群圈选分群
     *
     * @param sysGroup 客群圈选分群
     * @return 结果
     */
    public int insertSysGroup(SysGroup sysGroup) throws ServerException;

    /**
     * 新增客群圈选分群并导入客群客户数据
     *
     * @param
     * @return 结果
     */
    public CustIncrementVo insertSysGroupAndCustomer(MultipartFile file, String groupName, String custType, String groupId, String importType) throws IOException;

    /**
     * 修改客群圈选分群
     *
     * @param sysGroup 客群圈选分群
     * @return 结果
     */
    public int updateSysGroup(SysGroup sysGroup);

    /**
     * 批量删除客群圈选分群
     *
     * @param ids 需要删除的客群圈选分群主键集合
     * @return 结果
     */
    public int deleteSysGroupByIds(Long[] ids);

    /**
     * 删除客群圈选分群信息
     *
     * @param id 客群圈选分群主键
     * @return 结果
     */
    public int deleteSysGroupById(Long id);

    public int selectByGroupName(String groupName);


    /**
     * 新增客群圈选分群并导入客群客户数据
     *
     * @param
     * @return 结果
     */
    public AjaxResult insertSysGroupAndCustomerBySelect(String groupName, String custType,List<CustomerSelect> customerSelects);

}
